unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Nacistmapu1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Image1: TImage;
    CheckBox1: TCheckBox;
    Memo2: TMemo;
    Label1: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Button3: TButton;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Nacistmapu1Click(Sender: TObject);
    procedure KresliMesta;
    procedure KresliCesty;
    procedure VypisTrasu;
    procedure CheckBox1Click(Sender: TObject);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TMesto=record
           Jmeno:string;
           Pozice:TPoint;
         end;

  TCesta=record
           Start,Cil:TPoint;
           JmenoStartu,JmenoCile:string;
           Vzdalenost,Rychlost:Integer;
         end;

  TSpotreba=record
              Rychlost:Integer;
              Litru:Single;
            end;

  TProsle=array of Boolean; (* Hlidat, ktera mesta uz jsem zkousel *)

  TTrasa=record
           Prosle:TProsle;
           Delka:Integer;
         end;

var
  Form1: TForm1;
  MinRychlost,MaxRychlost,
  MinX,MinY,MaxX,MaxY:Integer; (* Hranice *)
  Mesta:array of TMesto;
  Cesty:array of TCesta;
  Spotreby:array of TSpotreba;
  StartCesty,CilCesty:string;
  Vybirani:Byte; (* 0=nic 1=vybira start 2=vybira cil *)
  Prosle:TProsle;
  Trasy:array of TTrasa; (* nalezene trasy *)

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  SetLength(Mesta,0);
  SetLength(Cesty,0);
  SetLength(Trasy,0);
  SetLength(Spotreby,0);
  Vybirani:=0;
  StartCesty:='';
  CilCesty:='';
end;

procedure CtiRadku(const S:TextFile;var Radka:string);
begin
  ReadLn(S,Radka);
  Radka:=Trim(Radka);
end;

function CisloMesta(Jmeno:string):Integer;
var
  C1:Integer;
begin
  Result:=-1000;
  for C1:=0 to Length(Mesta)-1 do
    if UpperCase(Mesta[C1].Jmeno)=UpperCase(Jmeno) then
      begin
        Result:=C1;
        Exit;
      end;
end;

function NajdiPozici(Jmeno:string):TPoint;
var
  C1:Integer;
begin
  Result:=Point(-10000,-10000);
  for C1:=0 to Length(Mesta)-1 do
    if UpperCase(Mesta[C1].Jmeno)=UpperCase(Jmeno) then
      begin
        Result:=Mesta[C1].Pozice;
        Exit;
      end;
end;

procedure TForm1.KresliMesta;
var
  C1:Integer;
begin
  with Image1.Canvas do
    begin
      Brush.Color:=clWhite;
      Brush.Style:=bsSolid;
      FillRect(Rect(0,0,
                    Width,Height));
      Brush.Style:=bsClear;
      for C1:=0 to Length(Mesta)-1 do
        begin
          Pen.Color:=clRed;
          Rectangle(Mesta[C1].Pozice.X-3+20,Mesta[C1].Pozice.Y-3+20,
                    Mesta[C1].Pozice.X+3+20,Mesta[C1].Pozice.Y+3+20);
          TextOut(Mesta[C1].Pozice.X+20,Mesta[C1].Pozice.Y+20,Mesta[C1].Jmeno);
        end;
    end;
end;

procedure TForm1.KresliCesty;
var
  C1:Integer;
begin
  with Image1.Canvas do
    begin
      Brush.Style:=bsClear;
      for C1:=0 to Length(Cesty)-1 do
        begin
          if Cesty[C1].Rychlost>90 then
            Pen.Width:=2
          else
            Pen.Width:=1;
          (* svetlejsi = rychlejsi *)
          Pen.Color:=RGB(0,(Cesty[C1].Rychlost-MinRychlost div 2)*2,0);

          MoveTo(Cesty[C1].Start.X+20,Cesty[C1].Start.Y+20);
          LineTo(Cesty[C1].Cil.X+20,Cesty[C1].Cil.Y+20);
        end;
    end;
end;

function Uprav(Radka:string):string;
begin
  (* odstrani des. oddelovace *)
  Result:=Radka;
  if Pos('.',Radka)>0 then
    Delete(Result,Pos('.',Radka),1);
  if Pos(',',Radka)>0 then
    Delete(Result,Pos(',',Radka),1);
end;

procedure TForm1.Nacistmapu1Click(Sender: TObject);
var
  C1:Integer; (* Cykly *)
  S:TextFile; (* Soubor *)
  Radka:string;
begin
  if OpenDialog1.Execute then
    begin
      SetLength(Mesta,0);
      SetLength(Cesty,0);
      with Image1.Canvas do
        begin
          Font.Color:=clBlack;
          Font.Size:=8;
          Font.Name:='Courier New';
        end;

      Image1.Picture.Bitmap.Width:=640;
      Image1.Picture.Bitmap.Height:=480;
      Image1.Width:=640;
      Image1.Height:=480;


      AssignFile(S,OpenDialog1.FileName);
      Reset(S);
      CtiRadku(S,Radka); (* hlavicka *)
      CtiRadku(S,Radka);
      if UpperCase(Radka)<>'<MAPA>' then
        begin
          ShowMessage('Nekorektni soubor');
          Exit;
        end;
(* MESTA *)
      CtiRadku(S,Radka);
      if UpperCase(Radka)<>'<MESTA>' then
        begin
          ShowMessage('Nebyla zadana mesta');
          Exit;
        end;
      (* Nacitani mest *)
      repeat
        CtiRadku(S,Radka);
        (* Konec mest *)
        if UpperCase(Radka)='</MESTA>' then
          Break;

        if UpperCase(Radka)='<MESTO>' then
          begin
            SetLength(Mesta, Length(Mesta)+1);
            (* Nazev mesta *)
            CtiRadku(S,Radka);
            if Pos('<NAZEV>',UpperCase(Radka))=1 then
              begin
                Delete(Radka,1,7);
                if Pos('<',Radka)>0 then
                  Radka:=Copy(Radka,1,Pos('<',Radka)-1);
              end;
            Mesta[Length(Mesta)-1].Jmeno:=Radka;
            (* Pozice mesta *)
            CtiRadku(S,Radka);
            if Pos('<POLOHAX>',UpperCase(Radka))=1 then
              begin
                Delete(Radka,1,9);
                if Pos('<',Radka)>0 then
                  Radka:=Copy(Radka,1,Pos('<',Radka)-1);
              end;
            Mesta[Length(Mesta)-1].Pozice.X:=StrToInt(Radka);

            CtiRadku(S,Radka);
            if Pos('<POLOHAY>',UpperCase(Radka))=1 then
              begin
                Delete(Radka,1,9);
                if Pos('<',Radka)>0 then
                  Radka:=Copy(Radka,1,Pos('<',Radka)-1);
              end;
            Mesta[Length(Mesta)-1].Pozice.Y:=StrToInt(Radka);

            (* Zjistovani hranic *)
            if Length(Mesta)=1 then
              begin
                MinX:=Mesta[Length(Mesta)-1].Pozice.X;
                MaxX:=Mesta[Length(Mesta)-1].Pozice.X;
                MinY:=Mesta[Length(Mesta)-1].Pozice.Y;
                MaxY:=Mesta[Length(Mesta)-1].Pozice.Y;
              end
            else
              begin
                if Mesta[Length(Mesta)-1].Pozice.X<MinX then
                  MinX:=Mesta[Length(Mesta)-1].Pozice.X;
                if Mesta[Length(Mesta)-1].Pozice.X>MaxX then
                  MaxX:=Mesta[Length(Mesta)-1].Pozice.X;
                if Mesta[Length(Mesta)-1].Pozice.Y<MinY then
                  MinY:=Mesta[Length(Mesta)-1].Pozice.Y;
                if Mesta[Length(Mesta)-1].Pozice.Y>MaxY then
                  MaxY:=Mesta[Length(Mesta)-1].Pozice.Y;
              end;

            CtiRadku(S,Radka); (* </mesto> *)
          end;
      until UpperCase(Radka)='</MESTA>'; (* NACTENA MESTA *)
(* Posunout si mesta a roztahnout na celou plochu, nechat rezervu *)
      for C1:=0 to Length(Mesta)-1 do
        begin
          Mesta[C1].Pozice.X:=Round((Mesta[C1].Pozice.X-MinX)
                                     *(Image1.Picture.Bitmap.Width-100)/(MaxX-MinX));
          Mesta[C1].Pozice.Y:=Round((Mesta[C1].Pozice.Y-MinY)
                                     *(Image1.Picture.Bitmap.Height-100)/(MaxY-MinY));
        end;


(* CESTY *)
      CtiRadku(S,Radka);
      if UpperCase(Radka)<>'<CESTY>' then
        begin
          ShowMessage('Nebyly zadany cesty');
          Exit;
        end;
      (* Nacitani cest *)
      repeat
        CtiRadku(S,Radka);
        (* Konec cest *)
        if UpperCase(Radka)='</CESTY>' then
          Break;

        if UpperCase(Radka)='<CESTA>' then
          begin
            SetLength(Cesty, Length(Cesty)+1);
            (* Nazev mesta 1 *)
            CtiRadku(S,Radka);
            if Pos('<Z>',UpperCase(Radka))=1 then
              begin
                Delete(Radka,1,3);
                if Pos('<',Radka)>0 then
                  Radka:=Copy(Radka,1,Pos('<',Radka)-1);
              end;
            Cesty[Length(Cesty)-1].JmenoStartu:=Radka;
            Cesty[Length(Cesty)-1].Start:=NajdiPozici(Radka);
            (* Nazev mesta 2 *)
            CtiRadku(S,Radka);
            if Pos('<DO>',UpperCase(Radka))=1 then
              begin
                Delete(Radka,1,4);
                if Pos('<',Radka)>0 then
                  Radka:=Copy(Radka,1,Pos('<',Radka)-1);
              end;
            Cesty[Length(Cesty)-1].JmenoCile:=Radka;
            Cesty[Length(Cesty)-1].Cil:=NajdiPozici(Radka);
            (* Vzdalenost *)
            CtiRadku(S,Radka);
            if Pos('<VZDALENOST>',UpperCase(Radka))=1 then
              begin
                Delete(Radka,1,12);
                if Pos('<',Radka)>0 then
                  Radka:=Copy(Radka,1,Pos('<',Radka)-1);
              end;
            Cesty[Length(Cesty)-1].Vzdalenost:=StrToInt(Radka);
            (* Rychlost *)
            CtiRadku(S,Radka);
            if Pos('<PRUMERNARYCHLOST>',UpperCase(Radka))=1 then
              begin
                Delete(Radka,1,18);
                if Pos('<',Radka)>0 then
                  Radka:=Copy(Radka,1,Pos('<',Radka)-1);
              end;
            Cesty[Length(Cesty)-1].Rychlost:=StrToInt(Radka);

            (* Zjistovani hranic *)
            if Length(Cesty)=1 then
              begin
                MinRychlost:=Cesty[Length(Cesty)-1].Rychlost;
                MaxRychlost:=Cesty[Length(Cesty)-1].Rychlost;
              end
            else
              begin
                if Cesty[Length(Cesty)-1].Rychlost<MinRychlost then
                  MinRychlost:=Cesty[Length(Cesty)-1].Rychlost;
                if Cesty[Length(Cesty)-1].Rychlost>MaxRychlost then
                  MaxRychlost:=Cesty[Length(Cesty)-1].Rychlost;
              end;

            CtiRadku(S,Radka); (* </cesta> *)
          end;
      until UpperCase(Radka)='</CESTY>'; (* NACTENE CESTY *)

(* SPOTREBA *)
      CtiRadku(S,Radka);
      if UpperCase(Radka)<>'<SPOTREBY>' then
        begin
          ShowMessage('Nebyly zadany spotreby');
          Exit;
        end;
      (* Nacitani spotreb *)
      repeat
        CtiRadku(S,Radka);
        (* Konec spotreb *)
        if UpperCase(Radka)='</SPOTREBY>' then
          Break;

        if UpperCase(Radka)='<SPOTREBA>' then
          begin
            SetLength(Spotreby,Length(Spotreby)+1);
            (* Rychlost *)
            CtiRadku(S,Radka);
            if Pos('<RYCHLOST>',UpperCase(Radka))=1 then
              begin
                Delete(Radka,1,10);
                if Pos('<',Radka)>0 then
                  Radka:=Copy(Radka,1,Pos('<',Radka)-1);
              end;
            Spotreby[Length(Spotreby)-1].Rychlost:=StrToInt(Radka);
            (* Litru *)
            CtiRadku(S,Radka);
            if Pos('<LITRU>',UpperCase(Radka))=1 then
              begin
                Delete(Radka,1,7);
                if Pos('<',Radka)>0 then
                  Radka:=Copy(Radka,1,Pos('<',Radka)-1);
              end;
            Spotreby[Length(Spotreby)-1].Litru:=StrToInt(Uprav(Radka))/10;
            CtiRadku(S,Radka); (* </spotreby> *)
          end;
      until UpperCase(Radka)='</SPOTREBY>'; (* NACTENE SPOTREBY *)


      SetLength(Prosle,Length(Mesta));

      CloseFile(S); (* Nacteno *)

(* Zobrazit *)
      KresliMesta;
      KresliCesty;
    end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  if TCheckBox(Sender).Checked then
    begin
      KresliMesta;
      KresliCesty;
    end
  else
    begin
      KresliMesta;
    end;
end;

function Nuly(Radka:string;Mist:Integer):string;
var
  C1:Integer;
begin
  (* doplneni textu nulami na zacatku *)
  Result:=Radka;
  for C1:=1 to Mist-Length(Radka) do
    Result:='0'+Result;
end;

function VypisCas(Cas:Single):string;
begin
  (* uprava des. cisla na hod:min *)
  Result:=IntToStr(Trunc(Cas))+':'+
          Nuly(IntToStr(Round(Frac(Cas)*60)),2);
end;

procedure HledejCestu(Start,Cil:String;UjetaDelka:Integer;Prosle:TProsle);
var
  C1:Integer;
  LokalniProsle:TProsle;
begin
  (* Rekurzivni hledani - prilis nefunguje *)
  Application.ProcessMessages;
  for C1:=0 to Length(Cesty)-1 do
    begin
      if(Cesty[C1].JmenoStartu=Start)
      and(not Prosle[CisloMesta(Cesty[C1].JmenoCile)])then
        begin
          Prosle[CisloMesta(Cesty[C1].JmenoCile)]:=True;
          LokalniProsle:=Copy(Prosle,0,Length(Prosle));
          if Cesty[C1].JmenoCile=Cil then
            begin
              SetLength(Trasy,Length(Trasy)+1);
              Trasy[Length(Trasy)-1].Delka:=UjetaDelka+Cesty[C1].Vzdalenost;
              Trasy[Length(Trasy)-1].Prosle:=Copy(Prosle,0,Length(Prosle));
{              ShowMessage(StartCesty+' -> '+CilCesty+#13#10+IntToStr(UjetaDelka+Cesty[C1].Vzdalenost));}
            end
          else
            HledejCestu(Cesty[C1].JmenoCile,Cil,UjetaDelka+Cesty[C1].Vzdalenost,LokalniProsle);
          Prosle[CisloMesta(Cesty[C1].JmenoCile)]:=False;
        end;

      if(Cesty[C1].JmenoCile=Start)
      and(not Prosle[CisloMesta(Cesty[C1].JmenoStartu)])then
        begin
          Prosle[CisloMesta(Cesty[C1].JmenoStartu)]:=True;
          LokalniProsle:=Copy(Prosle,0,Length(Prosle));
          if Cesty[C1].JmenoStartu=Cil then
            begin
              SetLength(Trasy,Length(Trasy)+1);
              Trasy[Length(Trasy)-1].Delka:=UjetaDelka+Cesty[C1].Vzdalenost;
              Trasy[Length(Trasy)-1].Prosle:=Copy(Prosle,0,Length(Prosle));
{              ShowMessage(StartCesty+' -> '+CilCesty+#13#10+IntToStr(UjetaDelka+Cesty[C1].Vzdalenost));}
            end
          else
            HledejCestu(Cesty[C1].JmenoCile,Cil,UjetaDelka+Cesty[C1].Vzdalenost,LokalniProsle);
          Prosle[CisloMesta(Cesty[C1].JmenoStartu)]:=False;
        end;
    end;
end;

procedure TForm1.VypisTrasu;
var
  C1,NejkratsiDelka,NejkratsiTrasa:Integer;
begin
  for C1:=0 to Length(Trasy)-1 do
     begin
       if C1=0 then
         begin
           NejkratsiDelka:=0;
           NejkratsiTrasa:=0;
         end;
       if Trasy[C1].Delka<NejkratsiDelka then
         begin
           NejkratsiDelka:=Trasy[C1].Delka;
           NejkratsiTrasa:=C1;
         end;
     end;
  (* Vypis proslych *)
  Memo2.Lines.Clear;
  Memo2.Lines.Add(StartCesty);
  for C1:=0 to Length(Trasy[NejkratsiTrasa].Prosle)-1 do
    begin
      if Trasy[NejkratsiTrasa].Prosle[C1]then
        Memo2.Lines.Add(Mesta[C1].Jmeno);
    end;
end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  C1,C2:Integer;
begin
  (* Zjistit, nad kterym mestem *)
  for C1:=0 to Length(Mesta)-1 do
    if(Abs(X-(Mesta[C1].Pozice.X+20))<5)
    and(Abs(Y-(Mesta[C1].Pozice.Y+20))<5)then
      begin
        (* pokud vybiral, hledat *)
        if Vybirani=1 then
          begin
            StartCesty:=Mesta[C1].Jmeno;
            Vybirani:=0;
            Label4.Visible:=False;
            Button1.Caption:=StartCesty;
            if CilCesty<>'' then
              begin
                for C2:=0 to Length(Prosle)-1 do
                  Prosle[C2]:=False;
                SetLength(Trasy,0);
                Screen.Cursor:=crHourGlass;
                HledejCestu(StartCesty,CilCesty,0,Prosle);
                VypisTrasu;
                Screen.Cursor:=crDefault;
                Button1.Caption:='';
                Button2.Caption:='';
                StartCesty:='';
                CilCesty:='';
              end;
            Exit;
          end;
        if Vybirani=2 then
          begin
            CilCesty:=Mesta[C1].Jmeno;
            Vybirani:=0;
            Label4.Visible:=False;
            Button2.Caption:=CilCesty;
            if StartCesty<>'' then
              begin
                for C2:=0 to Length(Prosle)-1 do
                  Prosle[C2]:=False;
                SetLength(Trasy,0);
                Screen.Cursor:=crHourGlass;
                HledejCestu(StartCesty,CilCesty,0,Prosle);
                VypisTrasu;
                Screen.Cursor:=crDefault;
                Button1.Caption:='';
                Button2.Caption:='';
                StartCesty:='';
                CilCesty:='';
              end;
            Exit;
          end;
        (* nehledat, vypsat prime spoje *)
        Form1.Caption:=Mesta[C1].Jmeno;
        Memo2.Clear;
        Memo2.Lines.Add('z: '+Mesta[C1].Jmeno);
        Memo2.Lines.Add('');
        for C2:=0 to Length(Cesty)-1 do
          begin
            (* pozor - cesty vedou obema smery *)
            if(Cesty[C2].JmenoStartu=Mesta[C1].Jmeno)then
              begin
                Memo2.Lines.Add('do: '+Cesty[C2].JmenoCile);
                Memo2.Lines.Add('delka: '+IntToStr(Cesty[C2].Vzdalenost)+' km');
                Memo2.Lines.Add('doba jizdy: '+VypisCas(Cesty[C2].Vzdalenost/Cesty[C2].Rychlost)+' hod.');
                Memo2.Lines.Add('');
              end;
            if(Cesty[C2].JmenoCile=Mesta[C1].Jmeno)then
              begin
                Memo2.Lines.Add('do: '+Cesty[C2].JmenoStartu);
                Memo2.Lines.Add('delka: '+IntToStr(Cesty[C2].Vzdalenost)+' km');
                Memo2.Lines.Add('doba jizdy: '+VypisCas(Cesty[C2].Vzdalenost/Cesty[C2].Rychlost)+' hod.');
                Memo2.Lines.Add('');
              end;
          end;
        Exit;
      end;
  Form1.Caption:='Mapa';
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  C1:Integer;
begin
  (* Pohyb nad mapou *)
  for C1:=0 to Length(Mesta)-1 do
    if(Abs(X-(Mesta[C1].Pozice.X+20))<5)
    and(Abs(Y-(Mesta[C1].Pozice.Y+20))<5)then
      begin
        Form1.Caption:=Mesta[C1].Jmeno+' - kliknutim zjistite spojeni do okolnich mest';
        Exit;
      end;
  Form1.Caption:='Mapa';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Vybirani:=1;
  Label4.Visible:=True;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Vybirani:=2;
  Label4.Visible:=True;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  (* zrusit vybirani *)
  Vybirani:=0;
  Button1.Caption:='';
  Button2.Caption:='';
  StartCesty:='';
  CilCesty:='';
  Label4.Visible:=False;
end;

end.
